<?php
/**
 * Show Admin notices easily
 * @version 1.0.0
 * @package InnoMobile
 * @author PS
 */
namespace InnoMobile;
if ( !class_exists( 'InnoMobile\Admin_Notice') ) :
    class Admin_Notice {
        var $message_type;
        var $message_text;

        /**
         * Choose type and text of a message that should be shown in Admin
         * @param string $message_type can be error, warning, success, info
         * @param string $message_text Text that will be shown
         */
        public function __construct($message_text, $message_type) {
            $this->message_type = $message_type;
            $this->message_text = $message_text;
            
            add_action( 'admin_notices', array($this, 'admin_show_notice'));

        }

        /**
         * Show Admin notice
         */
        public function admin_show_notice() {
            $class = 'notice is-dismissible notice-'.$this->message_type;
            printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $this->message_text ); 
        }
    }
    if ( ! function_exists( 'add_notice' ) ) {
        function add_notice( $message, $type = 'update' ) {
                new Admin_Notice( $message, $type );
        }
    }
endif;