<?php 
/**
 * Create WordPress Dashboard Widgets easily
 * @package InnoMobile
 * @author PS
 * @version 1.0.0
 */
namespace InnoMobile;
    
if ( !class_exists( 'InnoMobile\Dashboard_Widget') ) :
class Dashboard_Widget {
    var $admin_url;
    var $id;
    var $title;
    var $code;
    var $capability;

    /**
     * 
     * @param type $code Content of the Dashboard Widget
     * @param type $capability Which capability is neccessary to enable the widget
     */
    public function __construct($id, $title, $code, $capability) {
        $this->admin_url = get_admin_url();
        $this->code = $code;
        $this->title = $title;
        $this->id = $id;
        $this->capability = $capability;
        add_action( 'wp_dashboard_setup', array($this, 'add_dashboard_widget'));
    }
    
    /**
     * Add the template widget to the dashboard.
    */
    function add_dashboard_widget() {  
        if(current_user_can($this->capability)) {
            wp_add_dashboard_widget(
                $this->id, // Widget slug.
                $this->title, // Title.
                array($this, 'create_dashboard_widget') // Display function.
            );
        }
    }
    
    /**
     * Create Dashboard Widget
     */
    function create_dashboard_widget() {
        echo $this->code;
    }
}
endif;