<?php

/**
 * Create Meta boxes and fields easily
 * @package InnoMobile
 * @version 1.0.0
 * @author PS
 */
namespace InnoMobile;
if ( !class_exists( 'InnoMobile\Meta_Box') ) :
class Meta_Box {
    var $meta_id;
    var $meta_title;
    var $meta_post_type;
    var $meta_position;
    var $meta_prio;
    
    protected $_meta_box;
    protected $_fields;
    
    /**
     * To use class with plugins and themes
     * @var type 
     */
    protected $selfPath;
    
    /**
     * Array Fields = id, title, post_type, position, prio, fields, use_with_theme
     * @param array $meta_box
     */
    public function __construct($meta_box) {
        $this->_meta_box = $meta_box;
        $this->_fields = $this->_meta_box['fields'];
        
        if(!isset($meta_box['use_with_theme']) || $meta_box['use_with_theme'] === false) {
            $this->selfPath = plugins_url( 'im-meta-class', plugin_basename( dirname( __FILE__ ) ) );
        } else {
            $this->selfPath = get_stylesheet_directory_uri() . '/im-meta-class';
        }   

        add_action('add_meta_boxes', array($this, 'meta_box'));
        add_action('save_post', array($this, 'save'));
    }
    
    function meta_box() {
        add_meta_box( $this->_meta_box['id'], $this->_meta_box['title'], array($this, 'show'), $this->_meta_box['post_type'], $this->_meta_box['position'], $this->_meta_box['prio'] );
    }
    
    function add_text($id, $args, $repeater=false) {
        $new_field = array(
            'id'=> $id,
            'title' => '',
            'type' => 'text'
        );
        $new_field = array_merge($new_field, $args);  
        if($repeater===true) {
            return $new_field;
        } else {
            $this->_fields[] = $new_field;
        }
        
    }
    
    function add_repeater($id, $args, $repeaterfields) {
        $new_field = array(
         'type'     => 'repeater',
         'id'       => $id,
         'title'     => 'Reapeater Field',
         'fields'   => $repeaterfields
       );
       $new_field = array_merge($new_field, $args);
       $this->_fields[] = $new_field;       
    }
    
    function show() {
        global $post;
	wp_nonce_field( basename( __FILE__ ), 'wppct_nonce' );
	$stored_meta = get_post_meta( $post->ID );
        
        foreach ( $this->_fields as $field ) {
            if(isset($stored_meta[$field['id']])) {
                $value = $stored_meta[$field['id']][0];
            } else {
                $value = '';
            }
            switch($field['type']) {
                case 'text' : 
                    $this->show_text($field, $value);                   
                    break;
                case 'repeater' :
                    $meta = get_post_meta($post->ID,$field['id'],true);
                    $this->show_repeater_fields($field, $meta);
                    break;
            }
        }      
    }
    
    function show_text($field, $value) {
        echo '<p><label for="'.$field['id'].'" class="wppct-row-title">'.$field['title'].'</label></p><input type="text" name="'.$field['id'].'" id="'.$field['id'].'" value="'.$value.'" />'; 
    }
    
    function show_repeater_fields($field, $value) {
        global $post;
        $plugin_path = '';
        $remove = __('Remove', 'wppct');
        $add =  __('Add New Placeholder', 'wppct');
        $c = 0;
        echo "<div class='im-repeat' id='{$field['id']}'>";
            echo '<div class="repeater-inner">';

            //Erstelle die Felder mit Inhalten
            if (count($value) > 0 && is_array($value)) {
                

                foreach ($value as $me) {
                    //for labling toggles
                    $mmm = isset($me[$field['fields'][0]['id']]) ? $me[$field['fields'][0]['id']] : "";
                    echo '<div class="im-repater-block">';

                    foreach ($field['fields'] as $f) {
                        //reset var $id for repeater
                        $id = '';
                        $id = $field['id'] . '[' . $c . '][' . $f['id'] . ']';
                        $m = isset($me[$f['id']]) ? $me[$f['id']] : '';
                        $m = ( $m !== '' ) ? $m : $f['std'];

                        //set new id for field in array format
                        $f['id'] = $id;
                        $this->show_text($f, $m); 
                        echo "<div class='re-control'><span class='button-remove remove-{$field['id']}'><i class='fa fa-minus-circle'></i></span></div>";
                        $c++;
                    }
                    echo '</div>';
                }
            }

            echo "<div class='button-add' id='add-{$field['id']}'><i class='fa fa-plus-circle'></i>{$add}</div>";
            echo '</div>';
            echo '</div>';

        //create all fields once more for js function and catch with object buffer
        ob_start();
        echo '<div class="im-repater-block">';

        foreach ($field['fields'] as $f) {
            //reset var $id for repeater
            $id = '';
            $id = $field['id'] . '[CurrentCounter][' . $f['id'] . ']';
            $f['id'] = $id;
            $this->show_text($f, '');
        }
        echo "<div class='re-control'><span class='button-remove remove-{$field['id']}'><i class='fa fa-minus-circle'></i></span></div>";
        echo '</div>';
        $counter = 'countadd_' . $field['id'];
        $js_code = ob_get_clean();
        $js_code = str_replace("\n", "", $js_code);
        $js_code = str_replace("\r", "", $js_code);
        $js_code = str_replace("'", "\"", $js_code);
        $js_code = str_replace("CurrentCounter", "' + " . $counter . " + '", $js_code);
        echo '<script>
            jQuery(document).ready(function() {
              var ' . $counter . ' = ' . $c . ';
              jQuery("#add-' . $field['id'] . '").on(\'click\', function() {
                
                jQuery(this).before(\'' . $js_code . '\'); 
                ' . $counter . ' = ' . $counter . ' + 1;    
                
              });
                  jQuery(document.body).on(\'click\', \'.remove-'.$field['id'].'\', function() {
                      console.log("Das Tippen wurde erkannt");
                        jQuery(this).parent().parent().remove();
                  });
              });
            </script>';
            
    }
    
    function save( $post_id ) {

        // Checks save status
        $is_autosave = wp_is_post_autosave( $post_id );
        $is_revision = wp_is_post_revision( $post_id );
        $is_valid_nonce = ( isset( $_POST[ 'wppct_nonce' ] ) && wp_verify_nonce( $_POST[ 'wppct_nonce' ], basename( __FILE__ ) ) ) ? 'true' : 'false';

        // Exits script depending on save status
        if ( $is_autosave || $is_revision || !$is_valid_nonce ) {
                return;
        }
        
        foreach ( $this->_fields as $field ) {
            if (isset($_POST[$field['id']])) {
                    switch ($field['type']) {
                        case 'text' :
                            update_post_meta($post_id, $field['id'], $_POST[$field['id']]);

                            break;
                        case 'repeater' :

                            $this->save_repeater($post_id, $field, $_POST[$field['id']]);

                            break;
                    }
                }
            }  
    }
    
    function save_repeater($post_id, $field, $new ) {
        if (is_array($new) && count($new) > 0) {
            $temp = array();
            foreach ($new as $n) {
                foreach ($field['fields'] as $f) {
                    $type = $f['type'];
                }
                $temp[] = $n;
            }
            if (isset($temp) && count($temp) > 0) {
                update_post_meta($post_id, $field['id'], $temp);
                return;
            }
        } 
        
        delete_post_meta($post_id, $field['id']);
        
    }
}
endif;